#include <iostream.h>
#include <typeinfo.h>

//----------------------------------------------------------
// 2D-Basisklasse
//----------------------------------------------------------
class GraphElement
{
	public:
	   virtual void Verschiebe (void) { cout << "Verschieben" << endl;}
};

//----------------------------------------------------------
// Beispiel fr abgeleitetes 2D-Objekt
//----------------------------------------------------------
class Kreis : public GraphElement
{
	public:
	   virtual void Verschiebe (void) { cout << "Kreis Verschieben" << endl;}
};

//----------------------------------------------------------
// 3D-Basisklasse
//----------------------------------------------------------
class Graph3D : public GraphElement
{
	public:
	   virtual void Verschiebe   (void) { cout << "2D-Verschieben" << endl;}
	   virtual void Verschiebe3D (void) { cout << "3D-Verschieben" << endl;}
};

//----------------------------------------------------------
// Beispiel fr abgeleitetes 3D-Objekt
//----------------------------------------------------------
class Kugel : public Graph3D
{
	public:
	   virtual void Verschiebe   (void) { cout << "2D-Kugel Verschieben" << endl;}
	   virtual void Verschiebe3D (void) { cout << "3D-Kugel Verschieben" << endl;}
};

//----------------------------------------------------------
// Testprogramm
//----------------------------------------------------------
void main (void)
{
   int i;

	//----------------------------------------------------------
	// Erzeugung einer (sehr) einfachen polymorphen Liste
	//----------------------------------------------------------
	Kreis         aKreis;
   Kugel         aKugel;
   GraphElement *Zeichnung[2] = {&aKreis, &aKugel};

	//----------------------------------------------------------
	// Hilfpointer fr 3D-Objekte
	//----------------------------------------------------------
	Graph3D *p3DObjekt = NULL;

	//----------------------------------------------------------
	// ber gesamte Liste gehen
	//----------------------------------------------------------
   for (i=0; i<2; i++)
   {
		//----------------------------------------------------------
		// 2D-Objektverschiebung geht immer
		//----------------------------------------------------------
   	Zeichnung[i]->Verschiebe();

		//----------------------------------------------------------
		// feststellen, ob es ein 3D-Objekt ist
		//----------------------------------------------------------
      p3DObjekt = dynamic_cast <Graph3D *>(Zeichnung[i]);
      if (p3DObjekt)
      {
			//----------------------------------------------------------
			// 3D-Verschiebung nur mit 3D-Objekten
			//----------------------------------------------------------
      	p3DObjekt->Verschiebe3D();
      }
   }
}

