#include <excpt.h>
#include <except.h>
#include <iostream.h>
#include <stdlib.h>

//------------------------------------------------------------------------------
// Eigene terminate-function
//------------------------------------------------------------------------------
void myTerminate ()
{
	cout << "myTerminate";
   abort();
}

void myUnexpected ()
{
	cout << "unerwartete Exception";
   abort();
}

//------------------------------------------------------------------------------
// Funktion mit Exceptionhandling
//------------------------------------------------------------------------------
double fnFakultaet (int Param)
{
   double Ergebnis = 1.0;

   //---------------------------------------------------------------------------
   // Exception auslsen
   //---------------------------------------------------------------------------
   if (Param > 100) throw 'P';
   if (Param > 50) throw "Parameter zu gro";
   if (Param < 0)  throw 1;

  	if (0 == Param) Param = 1;
   for (int i=Param; i>1; i--) Ergebnis *= i;

   return Ergebnis;
}

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
   char sEingabe [80];
   int fak = 0;
   terminate_function  OldTerminate;
   unexpected_function OldUnexpected;

   cout << "Parameter : ";
   cin.getline (sEingabe, 80);
   fak = atoi (sEingabe);

   //---------------------------------------------------------------------------
   // Eigene Termination und Unexpected
   //---------------------------------------------------------------------------
	OldTerminate  = set_terminate  (myTerminate);
   OldUnexpected = set_unexpected (myUnexpected);

   //---------------------------------------------------------------------------
   // Die folgenden Codezeilen berwachen (try-Block)
   //---------------------------------------------------------------------------
   try
   {
      cout << fnFakultaet (fak) << endl;
   }
   //---------------------------------------------------------------------------
   // Exceptionhandler, wird aufgerufen, wenn im try-Block eine Exception
   // ausgelst wird
   //---------------------------------------------------------------------------
   catch (char *pError)
   {
      cout << pError;
   }
   catch (int nError)
   {
      cout << "Schwerer Fehler: negative Fakultt";
      terminate();
   }
   //---------------------------------------------------------------------------
   // alle anderen Exceptiontypen laufen jetzt in myTerminate...
   //---------------------------------------------------------------------------


   cout << endl << "Programmende" << endl;
	set_terminate  (OldTerminate);
	set_unexpected (OldUnexpected);
}

